# -*- coding: utf-8 -*-

import random
import sys
import time
from xml.dom.minidom import  parseString

from amazonproduct.api import API
from amazonproduct.errors import AWSError
# from webapi.webStore.Amazon.amazonproduct.api import API
# from webapi.webStore.Amazon.amazonproduct.api import API
from django.utils.encoding import smart_str

from webapi.webStore.Amazon.amazonproduct import config as aws_config
from webapi.webStore.Amazon.mws import Orders, Products, Inventory, Reports, Feeds, InboundShipments, Subscriptions, \
    MWSError
from sale_amazon.config import *
reload(sys)
sys.setdefaultencoding('utf8')


class create_api_exception(Exception):
    def __init__(self, value , local):
         self.value = 'AWS.InvalidLocaleValue: ' + local +' is not a valid value for Locale'
    def __str__(self):
       return repr(self.value)


class MyAWSError(Exception):
    def __init__(self, value):
        self.value = value
    def __str__(self):
        return unicode(repr(self.value))
    # def __unicode__(self):
    #     return repr(self.value)


class Amazon_MWS(object):
    """amazon Merchant 相关,主要涉及到   网店订单获取,网店商品获取,网店商品库存获取,网店商品上传价格,"""
    def __init__(self,account):
        self.account = account
        self.access_key = account.ACCESS_KEY
        self.secret_key = account.SECRET_KEY
        self.account_id = account.ACCOUNT_ID
        self.mws_auth_token = account.MWSAuthToken
        self.MKPLACEID = account.MKPLACEID
        self.region = MARKET_TO_REGION.get(account.MKPLACEID)

    def __create_api(self, type):
        """创建api对象"""
        access_key = self.access_key
        secret_key = self.secret_key
        account_id = self.account_id
        mws_auth_token = self.mws_auth_token
        region = self.region

        if type == 'Orders':
            return Orders(access_key, secret_key, account_id,mws_auth_token,region = region)
        elif type == 'Inventory':
            return Inventory(access_key,secret_key, account_id,mws_auth_token,region = region)
        elif type == 'Products':
            return Products(access_key,secret_key, account_id,mws_auth_token,region = region)
        elif type == 'Reports':
            return Reports(access_key,secret_key, account_id,mws_auth_token,region = region)
        elif type == 'Feeds':
            return Feeds(access_key,secret_key, account_id,mws_auth_token,region = region)
        elif type == 'Inbounds':
            return InboundShipments(access_key,secret_key, account_id,mws_auth_token,region = region)
        elif type == 'Subscriptions':
            return Subscriptions(access_key,secret_key, account_id,mws_auth_token,region = region)
        else:
            error_msg = "Incorrect type supplied ('%(type)s')" % {"type" : type }
            raise MWSError(error_msg)

    def get_product_report(self,type):
        '''
            获取店铺库存报告API
            @param type:MWS的api获取报告的类型
        '''
        try:
            amazon = self.__create_api('Reports')
            orders = amazon.request_report(type,)
            data = orders.response.content
            next_dom = parseString(data)
            feed_submission_id = next_dom.getElementsByTagName("ReportRequestId")[0].childNodes[0].data
            timeout = 0
            while True:
                timeout = timeout + 1
                if timeout > 100:
                    raise Exception(type + '库存报告获取失败: get_report_request_list timeout')
                time.sleep(10)
                orders = amazon.get_report_request_list([feed_submission_id])
                data = orders.response.content
                next_dom = parseString(data)
                report_status = next_dom.getElementsByTagName("ReportProcessingStatus")[0].childNodes[0].data
                if report_status in ['_DONE_']:
                    break
            report_id = next_dom.getElementsByTagName("GeneratedReportId")[0].childNodes[0].data
            orders = amazon.get_report(report_id)
            data = orders.response.content
            return_data = []
            product_list = data.replace('\r','').split('\n')
            product_head = product_list[0].split('\t')
            index_length = len(product_head)
            # file_object = open('/home/cc/list%s.xlsx'%(self.account), 'w')
            # file_object.write(data)
            # file_object.close()
            for each_product in product_list[1:]:
                product_temp = {}
                product_info = each_product.split('\t')
                if len(product_info) <= 1:
                    continue
                for i in range(0,index_length):
                    product_temp[product_head[i]] = product_info[i]
                return_data.append(product_temp)
            return return_data
        except Exception,e:
            raise Exception(type+'库存报告获取失败: '+str(e))


    def get_product_product_relationship(self,ASINList=[]):
        """获取父子关系的"""
        amazon = self.__create_api('Products')
        marketplaceids = self.MKPLACEID
        product = {}
        if ASINList:
            if len(ASINList)>10:
                return {'result': False, 'error_message': "ASINList is't up 20."}
            sku_list_count = 1
            # while True:
            #     SellerSKU_temp = SellerSKU[(sku_list_count - 1) * 20:sku_list_count * 20]
            #     sku_list_count += 1
            #     if len(SellerSKU_temp) == 0:
            #         break
            #     else:
            product_result = amazon.get_matching_product(marketplaceids, asins=ASINList)
            product_result_content = product_result.response.content
            # file_object = open('/home/cc/product_asin.xml', 'w')
            # file_object.write(product_result_content)
            # file_object.close()
            xml_obj = parseString(product_result_content)
            GetMatchingProductResult = xml_obj.getElementsByTagName('GetMatchingProductResult')
            for ele in GetMatchingProductResult:
                product_item = {}
                asin = ele.getElementsByTagName('Identifiers')[0].getElementsByTagName('ASIN')[0].childNodes[0].data
                product_item['asin'] = asin
                relationships = ele.getElementsByTagName('Relationships')[0]
                if len(relationships.childNodes)>0:
                    children_ele = ele.getElementsByTagName('Relationships')[0].getElementsByTagName('ns2:VariationChild')
                    parent_ele = ele.getElementsByTagName('Relationships')[0].getElementsByTagName('VariationParent')
                    if children_ele:
                        product_item['parent'] = asin
                    elif parent_ele:
                        IsAutographed = get_element_by_tag(ele, 'AttributeSets', 'ns2:IsAutographed')
                        if not IsAutographed or IsAutographed != 'false':
                            parent_asin = parent_ele[0].getElementsByTagName('Identifiers')[0].getElementsByTagName('ASIN')[0].childNodes[0].data
                            product_item['parent'] = parent_asin
                        else:
                            pass
                            # product_item['parent'] = asin
                product.update({asin:product_item})

            return product
        else:
            return None


    def get_product_product_by_sku(self,skus=[]):
        """huoq"""
        amazon = self.__create_api('Products')

        marketplaceids = self.MKPLACEID
        product_seller_sku_list = {}
        if skus:
            if len(skus)>20:
                return {'result': False, 'error_message': "skus is't up 20."}
            sku_list_count = 1
            # while True:
            #     SellerSKU_temp = SellerSKU[(sku_list_count - 1) * 20:sku_list_count * 20]
            #     sku_list_count += 1
            #     if len(SellerSKU_temp) == 0:
            #         break
            #     else:
            my_product_result = amazon.get_matching_product_for_id(marketplaceids,type='SellerSKU', id=skus)
            my_product_result = my_product_result.response.content
            # file_object = open('/home/cc/product.xml', 'w')
            # file_object.write(my_product_result)
            # file_object.close()
            my_product_result = parseString(my_product_result)
            # for ele in my_product_result.getElementsByTagName('MarketplaceASIN'):
            #     product_seller_sku_list.update({ele.childNodes[1].data:ele.childNodes[0].data})

        else:
            return {'result': False, 'error_message': "ASINList is can't be empty."}

        return {'result': True, 'data': product_seller_sku_list}

    def get_product_product_seller_sku(self,asins):
        amazon = self.__create_api('Products')
        marketplaceids = self.MKPLACEID
        product_seller_sku_list = {}
        my_product_result = amazon.get_matching_product(marketplaceids, asins=asins)
        my_product_result = my_product_result.response.content
        # file_object = open('/home/cc/product.xml', 'w')
        # file_object.write(my_product_result)
        # file_object.close()
        my_product_result = parseString(my_product_result)
        for ele in my_product_result.getElementsByTagName('Product'):
            asin = ele.getElementsByTagName('MarketplaceASIN')[0].getElementsByTagName('ASIN')[0].childNodes[0].data
            seller_sku_node= ele.getElementsByTagName('ns2:PartNumber')
            if seller_sku_node:
                seller_sku = ele.getElementsByTagName('ns2:PartNumber')[0].childNodes[0].data
            else:
                seller_sku = asin
            product_seller_sku_list.update({asin:seller_sku})
        return product_seller_sku_list


    def submit_feed(self,file_url):
        '''上传操作'''
        amazon = self.__create_api('Feeds')
        with open(file_url) as _txt_f:
            feed_content = unicode(_txt_f.read(),'iso-8859-1')
        return_data = amazon.submit_feed(feed=feed_content,feed_type='_POST_FLAT_FILE_PRICEANDQUANTITYONLY_UPDATE_DATA_',
                                         content_type='text/tab-separated-values; charset=iso-8859-1')
        return_content = return_data.response.content
        # file_object = open('/home/cc/submit.xlm', 'w')
        # file_object.write(return_content)
        # file_object.close()
        # return_content = '<SubmitFeedResponse xmlns="http://mws.amazonaws.com/doc/2009-01-01/"><SubmitFeedResult><FeedSubmissionInfo><FeedSubmissionId>50937017306</FeedSubmissionId><FeedType>_POST_FLAT_FILE_PRICEANDQUANTITYONLY_UPDATE_DATA_</FeedType><SubmittedDate>2017-05-20T07:28:35+00:00</SubmittedDate><FeedProcessingStatus>_SUBMITTED_</FeedProcessingStatus></FeedSubmissionInfo></SubmitFeedResult><ResponseMetadata><RequestId>fbfc5912-a438-42d2-b4d1-e4f00fef1b05</RequestId></ResponseMetadata></SubmitFeedResponse>'

        xml_dom = parseString(return_content)
        feed_submission_id = xml_dom.getElementsByTagName("FeedSubmissionId")[0].childNodes[0].data
        while True:
            time.sleep(20)
            try:
                return_data = amazon.get_feed_submission_list([feed_submission_id])
            except MWSError,e:
                print e
            return_content = return_data.response.content
            # file_object = open('/home/cc/submit.xlm', 'w')
            # file_object.write(return_content)
            # file_object.close()
            xml_dom = parseString(return_content)
            feed_processing_status = xml_dom.getElementsByTagName('FeedProcessingStatus')[0].childNodes[0].data
            if feed_processing_status in ['_DONE_', '_CANCELLED_', '_DONE_NO_DATA_']:
                break
        feed_result = amazon.get_feed_submission_result(feed_submission_id)
        feed_result_content = feed_result.response.content
        return feed_result_content

    def get_feed_submission_list(self):
        '''获取过去90内的所有上传报告'''
        amazon = self.__create_api('Feeds')
        return_data = amazon.get_feed_submission_list()
        content = return_data.response.content
        # file_object = open('/home/cc/feed_list.xlsx', 'w')
        # file_object.write(content)
        # file_object.close()
        return return_data

    def get_report_rquest_list(self):
        '''获取过去90内的所有请求报告'''
        i = 0
        amazon = self.__create_api('Reports')
        return_data = amazon.get_report_request_list()
        content = return_data.response.content
        # file_object = open('/home/cc/report_list'+str(i)+'.xml', 'w')
        # file_object.write(content)
        # file_object.close()
        next_dom = parseString(content)
        has_next = next_dom.getElementsByTagName("HasNext")[0].childNodes[0].data
        while has_next:
            i+=1
            time.sleep(5)
            next_token = next_dom.getElementsByTagName("NextToken")[0].childNodes[0].data
            amazon.get_report_list_by_next_token(next_token)
            return_data = amazon.get_report_request_list()
            content = return_data.response.content
            # file_object = open('/home/cc/report_list' + str(i) + '.xml', 'w')
            # file_object.write(content)
            # file_object.close()
            next_dom = parseString(content)
            has_next = next_dom.getElementsByTagName("HasNext")[0].childNodes[0].data


class Amazon_AWS(object):
    '''
    amazon产品相关,主要涉及到品类树,产品信息
    '''
    threadpool = None
    graph = {}
    error_list = []
    local = 'us'
    number = 1
    error_number = 1

    def __create_api(self, local):
        """
        Create a API instance for request.
        @param local: The local where your want select.
        @return: Return a aws api.Search the key in config by local.
        """
        try:
            random_number = int(random.randint(0, len(aws_config.LOCALE_ACCESS[str(local)]) - 1))
            api = API(aws_config.LOCALE_ACCESS[str(local).lower()][random_number]['acc'],
                      aws_config.LOCALE_ACCESS[str(local).lower()][random_number]['sec'],
                      #'AKIAJEXGSZ6O2Y6GCVGA','D801IPdV5loOr29fW46/nVELHtsQZaWjh1M1Z1l3',
                      str(local).lower(), aws_config.ASSOCIATE_TAG)
            return api
        except Exception, e:
            print 'error', str(e)
            raise create_api_exception(e, local)

    def __parse_node_result(self, result):
        """Parse the result. The result source is a XML document."""
        category_list = {}
        category_list['name'] = result.BrowseNodes.BrowseNode.Name
        category_list['id'] = result.BrowseNodes.BrowseNode.BrowseNodeId
        category_list['leaf'] = False
        category_list['children'] = []
        try:
            for child in result.BrowseNodes.BrowseNode.Children.BrowseNode:
                category_list['children'].append(child.BrowseNodeId)
        except Exception, e:
            category_list['leaf'] = True
        return category_list

    def __item_lookup(self, asin, local='us', type=None):
        '''
            Use item_lookup method to request a product information.
            @param asin: The asin you want get product infomation
            @param local: The default is 'us' ,and you can set this as 'ca','cn','de','fr','jp','it','uk','us'
            @return:
                if success,this will return a product information as Json
                if false ,if will return {'status':False,'Msg':'Not have item'}
        '''
        if type is None:
            raise Exception('type isempty')
        try:
            api = self.__create_api(local)
            result = api.item_lookup(*asin, ResponseGroup=type, RelationshipType='Tracks')
            if result['Items']['Request']['IsValid'] == 'True':
                # file_object = open('/home/cc/listdd.xlsx', 'w')
                # file_object.write(result)
                # file_object.close()
                return  result
            else:
                raise Exception('Items Request IsValid')
        except AWSError,e:
            raise e
        except Exception, e:
            raise Exception(type+'类型获取失败:'+str(e))

    def __parse_product_result(self, result):
        """Parse the result. The result source is a XML document."""
        try:
            product = {}
            category_list = []
            try:
                node = result.Items.Item.BrowseNodes.BrowseNode
                while True:
                    category_id = node.BrowseNodeId.text
                    try:
                        node = node.Ancestors.BrowseNode
                    except Exception, e:
                        category_id = node.BrowseNodeId.text
                        category_list.append(category_id)
                        break
                    category_list.append(category_id)
            except Exception, e:
                category_list = []
                pass
            product['category'] = category_list
            product['asin'] = result.Items.Item.ASIN.text
            try:
                product['title'] = result.Items.Item.ItemAttributes.Title.text.replace("'", "`").replace('"', '`')
            except Exception, e:
                product['title'] = 'N/A'
            try:
                product['brand'] = result.Items.Item.ItemAttributes.Brand.text
            except Exception, e:
                product['brand'] = 'N/A'
            try:
                product['medium_image'] = smart_str(result.Items.Item.ImageSets.ImageSet.MediumImage.URL.text)
            except Exception, e:
                product['medium_image'] = ''
            product['image_list'] = []
            try:
                for ImageSet in result.Items.Item.ImageSets.iterchildren():
                    product['image_list'].append(smart_str(ImageSet.LargeImage.URL.text))
            except Exception, e:
                product['image_list'] = []

            try:
                product['salesrank'] = result.Items.Item.SalesRank.text
            except Exception, e:
                product['salesrank'] = '999999'
            try:
                product['description'] = result.Items.Item.EditorialReviews.EditorialReview.Content.text
            except Exception, e:
                product['description'] = 'N/A'

            product['detail'] = {}
            for attr in result.Items.Item.ItemAttributes.iterchildren():
                attr.tag = attr.tag.replace('{http://webservices.amazon.com/AWSECommerceService/2011-08-01}', '')
                if product['detail'].has_key(attr.tag) and attr.text is not None:
                    if type(product['detail'][attr.tag]) is not list:
                        product['detail'][attr.tag] = [product['detail'][attr.tag]]
                    product['detail'][attr.tag].append(smart_str(attr.text).replace("'", "`").replace('"', "'"))
                else:
                    if attr.text is not None:
                        product['detail'][attr.tag] = smart_str(attr.text).replace("'", "`").replace('"', "'")
                    else:
                        s = {}
                        for item in attr.iterchildren():
                            if item.text is not None:
                                item.tag = item.tag.replace(
                                    '{http://webservices.amazon.com/AWSECommerceService/2011-08-01}', '')
                                s[item.tag] = item.text
                        product['detail'][attr.tag] = s

            return {'result': True, 'data': product}
        except Exception, e:
            return {'result': False, 'error_message': str(e)}

    def ___parse_large(self, xml_obj):
        """解析Large返回来得xml数据"""
        product = {}
        try:
            items = xml_obj.Items.Item
            for item in items:
                product_item = {}
                try:
                    brand = item.ItemAttributes.Brand.text
                except:
                    brand = ""
                product_item.update({'brand': brand})
                try:
                    seller_sku = item.ItemAttributes.MPN.text
                except:
                    seller_sku=''
                product_item.update({'seller_sku':seller_sku})
                try:
                    features = item.ItemAttributes.Feature
                except:
                    features = []
                features_str = ''
                for feature in features:
                    features_str = features_str + feature.text
                product_item.update({'feature': features_str})
                try:
                    title = item.ItemAttributes.Title.text
                except:
                    title = ''
                product_item.update({'title': title})
                asin = item.ASIN
                try:
                    parent_asin = item.ParentASIN  # 无变体属性的产品，没有ParentASIN属性。会报错
                except:
                    parent_asin = None
                if not parent_asin:
                    product_item.update({'item_type': 'item'})
                elif asin == parent_asin:
                    product_item.update({'item_type': 'parent'})
                else:
                    product_item.update({'item_type': 'children', 'parent_asin': parent_asin.text})
                    variations = {}
                    try:
                        color = item.ItemAttributes.Color
                        variations.update({'color': color.text})
                    except:
                        pass
                    try:
                        size = item.ItemAttributes.Size
                        variations.update({'size': size.text})
                    except:
                        pass
                    product_item.update({'variations': variations})
                try:
                    currency = item.ItemAttributes.ListPrice.CurrencyCode
                    product_item.update({'currency': currency.text})
                except:
                    pass
                # try:
                #     price = item.ItemAttributes.ListPrice.Amount
                #     product_item.update({'price': round(float(price.text) / 100, 2)})
                # except:
                #     pass
                try:
                    medium_image = item.MediumImage.URL
                    product_item.update({'medium_image': medium_image.text})
                except:
                    pass
                try:
                    main_image = item.LargeImage.URL
                    product_item.update({'main_image': main_image.text})
                except:
                    pass
                image_list = []
                try:
                    for imageSet in  item.ImageSets.ImageSet:
                        if imageSet.get('Category') == 'variant':
                            image_list.append(imageSet.LargeImage.URL.text)
                except:
                    pass
                product_item.update({'images_url': image_list})

                try:
                    detail = item.EditorialReviews.EditorialReview.Content
                    product_item.update({'detail': detail.text})
                except:
                    pass
                try:
                    lowest_price = item.OfferSummary.LowestNewPrice.Amount.text  ##无库存的产品，商场就没有在售该商品的，所有不能获取最低价格
                    product_item.update({'lowest_price': round(float(lowest_price) / 100, 2)})
                except:
                    pass
                try:
                    offer_num = item.Offers.TotalOffers
                    product_item.update({'offers_num': offer_num.text})
                except:
                    pass
                try:
                    sales_rank = item.SalesRank.text
                except:
                    sales_rank = ""
                product_item.update({'sales_rank': sales_rank})
                try:
                    parent_asin = item.ParentASIN.text
                except:
                    parent_asin = ""
                product_item.update({'parent_asin': parent_asin})

                product.update({item.ASIN: product_item})
            return product
        except Exception, e:
            raise Exception(item.ASIN.text + '获取Large出现问题' + str(e))

    def get_product_large(self,ASIN,local='us'):
        """根据asin来获取产品所有的信息"""
        try:
            result = self.__item_lookup(ASIN, local.lower(), 'Large,RelatedItems,SalesRank')
            return self.___parse_large(result)
        except Exception, e:
            raise e


    def ___parse_items_ids(self,xml_obj):
        """解析ItemIds返回来得xml数据"""
        product = {}  #{}
        try:
            items = xml_obj.Items.Item
            for item in items:
                product_item = {}
                product_item['asin'] = item.ASIN.text
                try:
                    product_item['parent'] = item.ParentASIN.text
                except:
                    pass
                product.update({item.ASIN:product_item})
            return product
        except Exception, e:
            raise Exception(item.ASIN.text+"itemIds解析出错:"+str(e))

    def get_items_ids(self,ASIN,local='us'):
        """根据asin来获取asin得父子关系"""
        try:
            result = self.__item_lookup(ASIN, local.lower(),'ItemIds')
            return self.___parse_items_ids(result)
        except Exception, e:
            raise e

    # def __parse_product_variations(self,xml_obj):
    #     main_product_list = []
    #     variation_product_list = []
    #
    #     try:
    #         items = xml_obj.Items.Item
    #         for item in items:
    #             main_product_item = {}
    #             variation_product_item = {}
    #             print item['ASIN']
    #             print item.ASIN
    #             if item.ASIN != item.ParentASIN:
    #                 continue;
    #
    #
    #     except Exception,e:
    #         return {'result':False,'error_message':str(e)}
    #
    # def get_product_variations(self,ASIN, local= 'US'):
    #     try:
    #         result = self.__item_lookup(ASIN, local.lower(),'Variations')
    #         if result['result'] is False:
    #             return result
    #         elif result['result'] is True:
    #             product = self.__parse_product_variations(result['data'])
    #
    #             if product['result'] is False:
    #                 return {'result': False, 'error_message': product['error_message']}
    #             elif product['result'] is True:
    #                 product['data']['local'] = local
    #                 return {'result': True, 'data': product['data']}
    #     except Exception, e:
    #         return {'result': False, 'error_message': str(e)}

    def __parse_product_attributes(self,xml_obj):
        """
        解析ResponseGroup为ItemAttributes时候，返回的xml文档
        :param xml_obj:
        :return:{
                asin:{'item_type':'parent','brand':'Nanna','title':title,'variations':'','feature',[Feature1,Feature2]},
                asin:{'item_type':'children','brand':'Nanna','title':title,'variations':{'color':'red','size':'L'},'feature',[Feature1,Feature2]},
        """
        product = {}
        try:
            items = xml_obj.Items.Item
            for item in items:
                product_item = {}
                try:
                    brand = item.ItemAttributes.Brand.text
                except:
                    brand = ""
                product_item.update({'brand': brand})
                try:
                    features = item.ItemAttributes.Feature
                except:
                    features = []
                features_str = ''
                for feature in features:
                    features_str = features_str + feature.text
                product_item.update({'feature': features_str})
                try:
                    title = item.ItemAttributes.Title.text
                except:
                    title = ''
                product_item.update({'title': title})
                asin = item.ASIN
                try:
                    parent_asin = item.ParentASIN    #无变体属性的产品，没有ParentASIN属性。会报错
                except:
                    parent_asin = None
                if not parent_asin:
                    product_item.update({'item_type': 'item'})
                elif asin == parent_asin:
                    product_item.update({'item_type': 'parent'})
                else:
                    product_item.update({'item_type': 'children','parent_asin':parent_asin.text})
                    variations = {}
                    try:
                        color = item.ItemAttributes.Color
                        variations.update({'color': color.text})
                    except:
                        pass
                    try:
                        size = item.ItemAttributes.Size
                        variations.update({'size': size.text})
                    except:
                        pass
                    product_item.update({'variations':variations})
                    try:
                        currency = item.ItemAttributes.ListPrice.CurrencyCode
                        product_item.update({'currency': currency.text})
                    except:
                        pass
                    try:
                        price =  item.ItemAttributes.ListPrice.Amount
                        product_item.update({'price': round(float(price.text)/100,2)})
                    except:
                        pass
                product.update({item.ASIN:product_item})
            return product
        except Exception, e:
            raise Exception(item.ASIN.text+'获取attribute出现问题'+str(e))

    def get_product_attributes(self, ASIN, local='us'):
        """
        Get a product information.
        @param ASIN:The asin value.
        @param local:The local value,default is 'us'
        @return:
        """
        try:
            result = self.__item_lookup(ASIN, local.lower(),'ItemAttributes')
            return self.__parse_product_attributes(result)
        except Exception, e:
            raise e

    def __parse_product_images(self,xml_obj):
        '''
        解析ResponseGroup为Images时候，返回的xml文档
        :param xml_obj:
        :return:
        '''
        product_images = {}
        try:
            items = xml_obj.Items.Item
            for item in items:
                product_images_item = {}
                try:
                    medium_image = item.MediumImage
                    product_images_item.update({'medium_image': medium_image.text})
                except:
                    pass
                try:
                    main_image = item.LargeImage
                    product_images_item.update({'main_image': main_image.text})
                except:
                    pass
                image_list = []
                try:
                    for imageSet in  item.ImageSets.ImageSet:
                        product_images_item = {}
                        if imageSet.get('Category') == 'variant':
                            image_list.append(imageSet.LargeImage.URL.text)
                except:
                    pass
                product_images_item.update({'images_url': image_list})
                product_images.update({item.ASIN:product_images_item})
            return  product_images
        except Exception, e:
            raise Exception(item.ASIN.text+'获取图片信息错误'+str(e))


    def get_product_images(self,ASIN,local='us'):
        """获取listing的图片信息"""
        try:
            result = self.__item_lookup(ASIN, local.lower(),'Images')
            return self.__parse_product_images(result)
        except Exception, e:
            raise e

    def __parse_product_editorial_review(self,xml_obj):
        """
        解析ResponseGroup为EditorialReview时候，返回的xml文档
        :param xml_obj:
        :return:
        """
        product_editorial_review = {}
        try:
            items = xml_obj.Items.Item
            for item in items:
                product_editorial_review_item = {}
                try:
                    detail = item.EditorialReviews.EditorialReview.Content
                    product_editorial_review_item = {'detail': detail.text}
                except:
                    pass
                product_editorial_review.update({item.ASIN: product_editorial_review_item})
            return product_editorial_review
        except Exception, e:
            raise Exception(item.ASIN.text+"获取描述出错"+str(e))

    def get_product_editorial_review(self,ASIN,local='us'):
        """获取listing的描述"""
        try:
            result = self.__item_lookup(ASIN, local.lower(), 'EditorialReview')
            return self.__parse_product_editorial_review(result)
        except Exception, e:
            raise e

    def __parse_product_offers_full(self,xml_obj):
        """
        解析ResponseGroup为offerFull时候，返回的xml文档
        :param xml_obj:
        :return:
        """
        product_offers = {}
        try:
            items = xml_obj.Items.Item
            for item in items:
                product_offers_item = {}
                offer_summery = item.OfferSummary
                # price = 0
                # for child in offer_summery.iterchildren():
                #     item_price = int(child.Amount.text)
                #     if price == 0 or item_price < price :
                #         price = item_price
                try:
                    lowest_price = item.OfferSummary.LowestNewPrice.Amount.text  ##无库存的产品，商场就没有在售该商品的，所有不能获取最低价格
                    product_offers_item = {'lowest_price': round(float(lowest_price) / 100, 2)}
                except:
                    pass
                try:
                    offer_num = item.Offers.TotalOffers
                    product_offers_item .update({'offers_num':offer_num.text})
                except:
                    pass
                product_offers.update({item.ASIN: product_offers_item})
            return product_offers
        except Exception, e:
            raise Exception(item.ASIN.text+'获取offer信息出错'+str(e))

    def get_product_offers_full(self,ASIN,local='us'):
        """获取产品的offer信息"""
        try:
            result = self.__item_lookup(ASIN, local.lower(), 'OfferFull')
            return self.__parse_product_offers_full(result)
        except Exception, e:
            raise e

    def __parse_product_sales_rank(self,xml_obj):
        """
        解析ResponseGroup为SalesRank时候，返回的xml文档
        :param xml_obj:
        :return:
        """""
        product_sales_rank = {}
        try:
            items = xml_obj.Items.Item
            for item in items:
                product_sales_rank_item = {}
                try:
                    sale_rank = item.SalesRank
                    product_sales_rank_item = {'sale_rank': sale_rank.text}
                except:
                    product_sales_rank_item = {'sale_rank': '0'}
                    pass
                product_sales_rank.update({item.ASIN: product_sales_rank_item})
            return product_sales_rank
        except Exception, e:
            raise Exception(item.ASIN.text+'获取排名出错'+str(e))

    def get_product_sales_rank(self,ASIN,local='us'):
        """获取产品的排名信息"""
        try:
            result = self.__item_lookup(ASIN, local.lower(), 'SalesRank')
            return self.__parse_product_sales_rank(result)
        except Exception, e:
            raise

    def get_product_review(self, ASIN, local='US'):
        try:
            result = self.__item_lookup(ASIN, local)
            if result['result'] is False:
                return result
            elif result['result'] is True:
                product = self.__parse_product_result(result['data'])

                if product['result'] is False:
                    return {'result': False, 'error_message': product['error_message'], 'ddddd': 'ddddd',
                            'fdsfd': product}
                elif product['result'] is True:
                    product['data']['local'] = local
                    return {'result': True, 'data': product['data']}
        except Exception, e:
            return {'result': False, 'error_message': str(e)}

def get_element_by_tag(item,name1,name2=None):
    value = item.getElementsByTagName(name1)
    if len(value) ==0:
        value = ""
    elif name2 is None :
        try:
            value = value[0].childNodes[0].data
        except:
            value =""
    else:
        value = get_element_by_tag(value[0],name2)
    return str(value).strip()